<?php
/**
 * @package JoomlaStats
 * @copyright Copyright (C) 2004-2009 JoomlaStats Team. All rights reserved.
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

//ensure this file is being included by a parent file
defined('_JEXEC') or die ('JS: Direct Access to this location is not allowed.');


//include JoomlaStats API
//to increase performance we include 'db.constants.php' instead of 'api.include.php'
//$js_PathToJoomlaStatsApi = JPATH_ADMINISTRATOR .DS. 'components' .DS. 'com_joomlastats' .DS. 'api' .DS. 'api.include.php';
$js_PathToJSDBConst = JPATH_ADMINISTRATOR .DS. 'components' .DS. 'com_joomlastats' .DS. 'database' .DS. 'db.constants.php';
if ( !is_readable($js_PathToJSDBConst) || !include_once($js_PathToJSDBConst) ) {
	$this_js_extension_homepage = 'http://www.joomlastats.org/index.php?option=com_content&amp;task=view&amp;id=32&amp;Itemid=38';//remeber to replace '&' by '&amp;'
	$this_js_extension_install_problem_text = '<div style="color: red;">It seams that <a href="'.$this_js_extension_homepage.'" target="_blank"><b>module \'Internet Browsers\' (mod_jstats_browser)</b></a> is not installed correctly. Please refer to <a href="http://www.joomlastats.org/entry/installation_noengine.php" target="_blank"><b>JoomlaStats extension installation problem</b></a> page.</div><br/><br/>';
	echo $this_js_extension_install_problem_text;
	return false; //this will end of this script //this also solve problem require_once (include_once now is enough and it generate only warning)
}




$list_time_period           = $params->get('list_time_period');
$list_length                = (int)$params->get('list_length');
$list_per_cent_prec_mode    = (int)$params->get('list_per_cent_prec_mode');
$header_show                = (bool)$params->get('header_show');
$header_text                = $params->get('header_text');
//$moduleclass_sfx          = $params->get('moduleclass_sfx');//joomla process this parameter internally
	


$db =& JFactory::getDBO();

	
$sql_constr_time = '1=1';//total
if ( $list_time_period != 'total' ) {
	require_once( JPATH_ROOT .DIRECTORY_SEPARATOR. 'administrator' .DIRECTORY_SEPARATOR. 'components' .DIRECTORY_SEPARATOR. 'com_joomlastats' .DIRECTORY_SEPARATOR. 'api' .DIRECTORY_SEPARATOR. 'module.php' );
	
	$JSApiModule = new js_JSApiModule();
	$sql_constr_time = $JSApiModule->getConditionStringFromXmlTimePeriodList( $list_time_period );
}

$query = '
	SELECT
		count(*) AS numbers,
		w.browser
	FROM
		#__jstats_ipaddresses w
		LEFT JOIN #__jstats_visits v ON(w.id = v.visitor_id)
	WHERE
		'.$sql_constr_time.'
		AND w.type='._JS_DB_IPADD__TYPE_REGULAR_VISITOR.'
	GROUP BY
		w.browser
	ORDER BY
		numbers DESC,
		w.browser ASC
';
//$query .= 'LIMIT '.$list_length;//this sql can not be limited. We must sum all visits to get number of visits with applied time period (and exclude) (we need sum to proper percent counting) //this problem could be solved by executing 2 queries - but is could be more time consuming than doing this in that way for large databases //result always be lower than 40 rows!!!


$db->setQuery($query);
$row_arr = $db->loadRowList();
if ($db->getErrorNum() > 0)
	echo $this_js_extension_install_problem_text;
		
$nbr_of_visitors_in_time_period = 0;
foreach( $row_arr as $row )
	$nbr_of_visitors_in_time_period += $row[0];


$result_arr = array();
for ($i=0; ($i<count($row_arr)) && ($i<$list_length); $i++)
{
	$nbr_of_visits = $row_arr[$i][0];
	$visits_in_percentage = (($nbr_of_visits/$nbr_of_visitors_in_time_period)*100);
	
	$per_cent_format_token = '%01.0f';
	if ($list_per_cent_prec_mode == 1)
		$per_cent_format_token = '%01.1f';
										
	$visits_in_percentage_formated = '';
	if ($visits_in_percentage < 1) //Apply '<' sign
		$visits_in_percentage_formated = '&lt;'.sprintf($per_cent_format_token, 1);
	else
		$visits_in_percentage_formated = sprintf($per_cent_format_token, $visits_in_percentage);
		
	$result_arr[] = array('percent' => $visits_in_percentage_formated, 'system' => $row_arr[$i][1]);
}




//
//
// TEMPLATE BELOW
//
//

$content = '';

if ($header_show == true)
	$content .= '<span class="small">'.$header_text.'</span><br/>';
	

$content .= '<table cellspacing="0" width="1">';//width="1" remove parameter auto from templates //this is solution for sizing and right aligning texts in columns (in FF and IE) (tested FF 2.0 and IE 7.0)
	
if (count($result_arr) > 0) {
	foreach( $result_arr as $row ) {
		$content .= '<tr>';
		$content .= '<td style="white-space: nowrap; text-align: right; padding-left: 1ex;">'.$row['percent'].'%</td>';		
		$content .= '<td style="white-space: nowrap; text-align: left;  padding-left: 1ex;">'.$row['system'].'</td>';		
		$content .= '</tr>';
	}
}
$content .= '</table>';

