<?php
/**
 * @package JoomlaStats
 * @copyright Copyright (C) 2004-2009 JoomlaStats Team. All rights reserved.
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */


//ensure this file is being included by a parent file
defined('_JEXEC') or die ('Direct Access to this location is not allowed.');


//include JoomlaStats API
//to increase performance we include 'db.constants.php' instead of 'api.include.php'
//$js_PathToJoomlaStatsApi = JPATH_ADMINISTRATOR .DS. 'components' .DS. 'com_joomlastats' .DS. 'api' .DS. 'api.include.php';
$js_PathToJSDBConst = JPATH_ADMINISTRATOR .DS. 'components' .DS. 'com_joomlastats' .DS. 'database' .DS. 'db.constants.php';
if ( !is_readable($js_PathToJSDBConst) || !include_once($js_PathToJSDBConst) ) {
	$this_js_extension_homepage = 'http://www.joomlastats.org/index.php?option=com_content&amp;task=view&amp;id=31&amp;Itemid=38';//remeber to replace '&' by '&amp;'
	$this_js_extension_install_problem_text = '<div style="color: red;">It seams that <a href="'.$this_js_extension_homepage.'" target="_blank"><b>module \'Latest Visitors\' (mod_jstats_latestvisitors)</b></a> is not installed correctly. Please refer to <a href="http://www.joomlastats.org/entry/installation_noengine.php" target="_blank"><b>JoomlaStats extension installation problem</b></a> page.</div><br/><br/>';
	echo $this_js_extension_install_problem_text;
	return false; //this will end of this script //this also solve problem require_once (include_once now is enough and it generate only warning)
}


$list_length                = (int)$params->get('list_length');
$LV_header_text             = $params->get('LV_header_text');
$LV_show_col_titles         = (bool)$params->get('LV_show_col_titles');
$LV_f_col_txt               = $params->get('LV_f_col_txt');
$LV_s_col_txt               = $params->get('LV_s_col_txt');

$time_diff_format           = $params->get('time_diff_format');

$general_view_type          = $params->get('general_view_type');//vert_one_row, vert_two_rows

$translation_tool           = $params->get('translation_tool');
//$moduleclass_sfx          = $params->get('moduleclass_sfx');//joomla process this paremeter internaly



$translation_arr = array();
//create translation array
if (strlen($translation_tool) > 0) {
	$trans_arr = explode(";", $translation_tool);
	foreach ($trans_arr as $trans) {
		$var_val_arr = explode("=", $trans);
		if ( !isset($var_val_arr[0]) || !isset($var_val_arr[1]) )
			continue;
		$var = trim($var_val_arr[0]);
		$val = trim($var_val_arr[1]);
		if ( (strlen($var_val_arr[0]) == 0) || (strlen($var_val_arr[1]) == 0) )
			continue;
		$translation_arr[$var] = $val;
	}
}

if (!defined('js_mod_jstats_latestvisitors_helper'))
{
	define('js_mod_jstats_latestvisitors_helper', true);
	

function js_FormatTimeDiff($time_diff, $time_diff_format, $translation_arr)
{ 
	$calc = abs($time_diff); 
	$days = floor($calc/86400); 
	$rest_days = $calc % 86400; 
	$hours = floor($rest_days/3600); 
	$rest_hours = $rest_days % 3600; 
	$minutes = floor($rest_hours/60); 
	$rest_minutes = $rest_hours % 60; 
	$seconds = floor($rest_minutes);
	
	$result = '';
	
	$days_s = '';
	{
		if ($days == 1)
			$days_s = $translation_arr['day_one']; 
		else
			$days_s = $translation_arr['day_many'];
			
		if ( isset($translation_arr['day_'.$days]) )
			$days_s = $translation_arr['day_'.$days];
	}

	$hours_s = '';
	{
		if ($hours == 1)
			$hours_s = $translation_arr['hour_one']; 
		else
			$hours_s = $translation_arr['hour_many'];
			
		if ( isset($translation_arr['hour_'.$hours]) )
			$hours_s = $translation_arr['hour_'.$hours];
	}
			
	$minutes_s = '';
	{
		if ($minutes == 1)
			$minutes_s = $translation_arr['minute_one']; 
		else
			$minutes_s = $translation_arr['minute_many'];
			
		if ( isset($translation_arr['minute_'.$minutes]) )
			$minutes_s = $translation_arr['minute_'.$minutes];
	}
		
	$seconds_s = '';
	{
		if ($seconds == 1)
			$seconds_s = $translation_arr['second_one']; 
		else
			$seconds_s = $translation_arr['second_many'];
		
		if ( isset($translation_arr['second_'.$seconds]) )
			$seconds_s = $translation_arr['second_'.$seconds];
	}
	

	//do not show zeros	
	if ($days == 0) {
		$days = '';
		$days_s = '';
	}
	if ($hours == 0) {
		$hours = '';
		$hours_s = '';
	}
	if ($minutes == 0) {
		$minutes = '';
		$minutes_s = '';
	}
	if ($seconds == 0) {
		$seconds = '';
		$seconds_s = '';
	}
	
	$hash_trans_arr = array(
		'##' => '#',
		'#d' => $days,
		'#e' => $days_s,
		'#h' => $hours,
		'#i' => $hours_s,
		'#m' => $minutes,
		'#n' => $minutes_s,
		'#s' => $seconds,
		'#t' => $seconds_s,
		);
		
	$row = strtr($time_diff_format, $hash_trans_arr);
	
	return $row; 
} 


function js_Table_LatestVisitors($limit)
{
	$db =& JFactory::getDBO();

	global $this_js_extension_install_problem_text;

	//should we use GROUP BY? Using group by we lost information about fact that user was logged (user can enter page, login, logout, exit page. Latest entry will be for anonymous user!)
	// !!!! We can not use 'last_visit_time_uts' member - it could give NOT the newest entry!!!!
	$query = ''
	. ' SELECT'
	. '   MAX(CAST(CONCAT(v.visit_date, \' \', v.visit_time) AS DATETIME))             AS last_visit_time,'
	. '   UNIX_TIMESTAMP(CAST(CONCAT(v.visit_date, \' \', v.visit_time) AS DATETIME))  AS last_visit_time_uts,'
	. '   v.joomla_userid         AS joomla_userid,'
	. '   w.nslookup              AS ns_lookup'
	. ' FROM'
	. '   #__jstats_visits v'
	. '   LEFT JOIN #__jstats_ipaddresses w ON (v.visitor_id = w.id)'
	. ' WHERE'
	. '   w.type='._JS_DB_IPADD__TYPE_REGULAR_VISITOR
	. ' GROUP BY'
	. '   v.visitor_id'
	. ' ORDER BY'
	. '   last_visit_time DESC'
	. ' LIMIT'
	. '   0, '.$limit
	;
	
	$db->setQuery($query);
	$row_arr = $db->loadObjectList();
	if ($db->getErrorNum() > 0)
		echo $this_js_extension_install_problem_text;
	
	for ($i=0; $i<count($row_arr); $i++ ) {
		// Calulate how long ago we've seen the user
		$row_arr[$i]->dif = time()-strtotime($row_arr[$i]->last_visit_time);
		//$row_arr[$i]->dif = time() - $row_arr[$i]->last_visit_time_uts;//see comment above sql
		
		$row_arr[$i]->user_name = $row_arr[$i]->ns_lookup;
		$row_arr[$i]->use_small_for_user_name = true;
		
		if ($row_arr[$i]->joomla_userid != 0) {
			// Get UserName from LoggedInName or NSLookup
			$query_line = 'SELECT #__users.name'
		        . ' FROM #__users'
		        . ' WHERE #__users.id='.$row_arr[$i]->joomla_userid;
        	$db->setQuery($query_line);
			$user_name = $db->loadResult();

            if ( strlen( $user_name ) > 0 ) {
            	$row_arr[$i]->user_name = $user_name;
				$row_arr[$i]->use_small_for_user_name = false;
			}
		}
	}
	
	return $row_arr;
}

}//end !defined('js_mod_jstats_latestvisitors_helper')




$row_arr = js_Table_LatestVisitors( $list_length );

//
// TEMPLATE below
//

$content = ''."\n";

if (strlen($LV_header_text) > 0)
	$content .= $LV_header_text.'<br/>'."\n";
	
if ( $general_view_type == 'vert_two_rows' )
	$content .= '<table cellspacing="0" width="100%">'."\n";//this line could brake template
else
	$content .= '<table cellspacing="0" width="1">'."\n";//width="1" remove parameter auto from templates //this is solution for sizing and right aligning texts in columns (in FF and IE) (tested FF 2.0 and IE 7.0)

	
if ( $LV_show_col_titles == true )
{
	if ( $general_view_type == 'vert_two_rows' ) {
		$content .= '<tr><td style="white-space: nowrap;"><b>'.$LV_f_col_txt.'</b></td></tr>';
		$content .= '<tr><td style="white-space: nowrap; text-align: right;"><b>'.$LV_s_col_txt.'</b></td></tr>'."\n";//column titles
	} else { //vert_one_row
		$content .= '<tr><td style="white-space: nowrap;"><b>'.$LV_f_col_txt.'</b></td><td style="white-space: nowrap; text-align: right;"><b>'.$LV_s_col_txt.'</b></td></tr>'."\n";//column titles
	}
}

foreach( $row_arr as $row ) {
	$dif = js_FormatTimeDiff($row->dif, $time_diff_format, $translation_arr);
	
	$user_name = $row->user_name;
	if ($row->use_small_for_user_name == true)
		$user_name = '<small><small>'.$row->user_name.'</small></small>';
	
	if ( $general_view_type == 'vert_two_rows' ) {
		$content .= '<tr><td style="white-space: nowrap;">&raquo;&nbsp;'.$user_name.'</td></tr>';
		$content .= '<tr><td style="white-space: nowrap; text-align: right;">'.$dif .'</td></tr>'."\n";
	} else { //vert_one_row
		$content .= '<tr><td style="white-space: nowrap;">&raquo;&nbsp;'.$user_name.'</td><td style="white-space: nowrap; text-align: right;">'.$dif.'</td></tr>'."\n";
	}
}

$content .= '</table>'."\n";

	
