<?php
/**
 * @package JoomlaStats
 * @copyright Copyright (C) 2004-2009 JoomlaStats Team. All rights reserved.
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */


//ensure this file is being included by a parent file
defined('_JEXEC') or die ('JS: Direct access to this location is not allowed.');


//include JoomlaStats API
//to increase performance we include 'db.constants.php' instead of 'api.include.php'
//$js_PathToJoomlaStatsApi = JPATH_ADMINISTRATOR .DS. 'components' .DS. 'com_joomlastats' .DS. 'api' .DS. 'api.include.php';
$js_PathToJSDBConst = JPATH_ADMINISTRATOR .DS. 'components' .DS. 'com_joomlastats' .DS. 'database' .DS. 'db.constants.php';
if ( !is_readable($js_PathToJSDBConst) || !include_once($js_PathToJSDBConst) ) {
	$this_js_extension_homepage = 'http://www.joomlastats.org/index.php?option=com_content&amp;task=view&amp;id=30&amp;Itemid=38';//remeber to replace '&' by '&amp;'
	$this_js_extension_install_problem_text = '<div style="color: red;">It seams that <a href="'.$this_js_extension_homepage.'" target="_blank"><b>module \'Top Visitors\' (mod_jstats_topvisitors)</b></a> is not installed correctly. Please refer to <a href="http://www.joomlastats.org/entry/installation_noengine.php" target="_blank"><b>JoomlaStats extension installation problem</b></a> page.</div><br/><br/>';
	echo $this_js_extension_install_problem_text;
	return false; //this will end of this script //this also solve problem require_once (include_once now is enough and it generate only warning)
}



$UserVisits                 = (int)$params->get('UserVisits');
$UV_header_text             = $params->get('UV_header_text');
$UV_show_col_titles         = (bool)$params->get('UV_show_col_titles');
$UV_f_col_txt               = $params->get('UV_f_col_txt');
$UV_s_col_txt               = $params->get('UV_s_col_txt');
$NSLookupVisits             = (int)$params->get('NSLookupVisits');
$NSLV_header_text           = $params->get('NSLV_header_text');
$NSLV_show_col_titles       = (bool)$params->get('NSLV_show_col_titles');
$NSLV_f_col_txt             = $params->get('NSLV_f_col_txt');
$NSLV_s_col_txt             = $params->get('NSLV_s_col_txt');
$Pages                      = (int)$params->get('Pages');
$P_header_text              = $params->get('P_header_text');
$P_show_col_titles          = (bool)$params->get('P_show_col_titles');
$P_f_col_txt                = $params->get('P_f_col_txt');
$P_s_col_txt                = $params->get('P_s_col_txt');
$NSLookupPages              = (int)$params->get('NSLookupPages');
$NSLP_header_text           = $params->get('NSLP_header_text');
$NSLP_show_col_titles       = (bool)$params->get('NSLP_show_col_titles');
$NSLP_f_col_txt             = $params->get('NSLP_f_col_txt');
$NSLP_s_col_txt             = $params->get('NSLP_s_col_txt');
//$moduleclass_sfx          = $params->get('moduleclass_sfx');//joomla process this paremeter internaly




if (!defined('js_mod_jstats_topvisitors_helper'))
{
	define('js_mod_jstats_topvisitors_helper', true);
	

function js_generateHtmlTable($row_arr, $header_txt, $show_col_titles, $f_col_txt, $s_col_txt, $use_small_in_list)
{
	$html_table = '';
	
	if (strlen($header_txt) > 0)
		$html_table .= '<tr><td colspan="2">'.$header_txt.'</td></tr>'."\n";
		
	if ( $show_col_titles == true )
		$html_table .= '<tr><td><b>'.$f_col_txt.'</b></td><td style="text-align: center;"><b>'.$s_col_txt.'</b></td></tr>'."\n";//column titles

	foreach( $row_arr as $row ) {
		if ($use_small_in_list == true)
			$html_table .= '<tr><td><small><small>'.$row[1].'</small></small></td><td  style="text-align: right;">'.$row[0].'</td></tr>'."\n";
		else
			$html_table .= '<tr><td>'.$row[1].'</td><td  style="text-align: right;">'.$row[0].'</td></tr>'."\n";
	}

	return $html_table;
}

		
function js_UserVisitsTable($limit, $header_txt, $show_col_titles, $f_col_txt, $s_col_txt)
{
	$db =& JFactory::getDBO();

	$query = '
		SELECT
			COUNT(*) AS number,
			u.name   AS name
        FROM
			#__jstats_visits v
			LEFT JOIN #__jstats_ipaddresses w ON (w.id=v.visitor_id)
			LEFT JOIN #__users u ON (u.id=v.joomla_userid)
        WHERE
			v.joomla_userid <> 0
			AND w.exclude <> 1
		GROUP BY
			v.joomla_userid
		ORDER BY
			number DESC
		LIMIT
			0, '.$limit
	;

	$db->setQuery($query);
	$row_arr = $db->loadRowList();


	$use_small_in_list = false;
	return js_generateHtmlTable($row_arr, $header_txt, $show_col_titles, $f_col_txt, $s_col_txt, $use_small_in_list);
}

function js_NSLookupVisitsTable($limit, $header_txt, $show_col_titles, $f_col_txt, $s_col_txt)
{
	$db =& JFactory::getDBO();

	$query = '
		SELECT
			COUNT(*)    AS number,
			w.nslookup  AS nslookup
        FROM
			#__jstats_visits v
			LEFT JOIN #__jstats_ipaddresses w ON (w.id=v.visitor_id)
        WHERE
			v.joomla_userid = 0
			AND w.type = 1
		GROUP BY
			w.nslookup
		ORDER BY
			number DESC
		LIMIT
			0, '.$limit
	;

	$db->setQuery($query);
	$row_arr = $db->loadRowList();


	$use_small_in_list = true;
	return js_generateHtmlTable($row_arr, $header_txt, $show_col_titles, $f_col_txt, $s_col_txt, $use_small_in_list);
}


function js_PagesTable($limit, $header_txt, $show_col_titles, $f_col_txt, $s_col_txt)
{
	$db =& JFactory::getDBO();

	$query = '
		SELECT
			COUNT(*) AS number,
			u.name   AS name
        FROM
			#__jstats_impressions i
			LEFT JOIN #__jstats_visits v ON (v.visit_id=i.visit_id)
			LEFT JOIN #__jstats_ipaddresses w ON (w.id=v.visitor_id)
			LEFT JOIN #__users u ON (u.id=v.joomla_userid)
        WHERE
			v.joomla_userid <> 0
			AND w.exclude <> 1
		GROUP BY
			v.joomla_userid
		ORDER BY
			number DESC
		LIMIT
			0, '.$limit
	;

	$db->setQuery($query);
	$row_arr = $db->loadRowList();


	$use_small_in_list = false;
	return js_generateHtmlTable($row_arr, $header_txt, $show_col_titles, $f_col_txt, $s_col_txt, $use_small_in_list);
}



function js_NSLookupPagesTable($limit, $header_txt, $show_col_titles, $f_col_txt, $s_col_txt)
{
	$db =& JFactory::getDBO();

	$query = '
		SELECT
			COUNT(*)   AS number,
			w.nslookup AS nslookup
        FROM
			#__jstats_impressions i
			LEFT JOIN #__jstats_visits v ON (v.visit_id=i.visit_id)
			LEFT JOIN #__jstats_ipaddresses w ON (w.id=v.visitor_id)
        WHERE
			v.joomla_userid = 0
		GROUP BY
			w.nslookup
		ORDER BY
			number DESC
		LIMIT
			0, '.$limit
	;

	$db->setQuery($query);
	$row_arr = $db->loadRowList();


	$use_small_in_list = true;
	return js_generateHtmlTable($row_arr, $header_txt, $show_col_titles, $f_col_txt, $s_col_txt, $use_small_in_list);
}

}//end if (!defined('js_mod_jstats_topvisitors_helper'))



/////////////////////////////////////////////////////////////////////////////////////////////////



$content = '';

if ( ($UserVisits > 0) || ($NSLookupVisits > 0) || ($Pages > 0) || ($NSLookupPages > 0) )
	$content .= "\n".'<table cellspacing="2" width="1">'."\n";//we must create one table to all sections. We want to have columns in all sections line up.  //width="1" remove parameter auto from templates //this is solution for sizing and right aligning texts in columns (in FF and IE) (tested FF 2.0 and IE 7.0) in j1.0.15 and j1.5.7


if ($UserVisits > 0)
	$content .= js_UserVisitsTable($UserVisits, $UV_header_text, $UV_show_col_titles, $UV_f_col_txt, $UV_s_col_txt);
if ($NSLookupVisits > 0)
	$content .= js_NSLookupVisitsTable($NSLookupVisits, $NSLV_header_text, $NSLV_show_col_titles, $NSLV_f_col_txt, $NSLV_s_col_txt);
if ($Pages > 0)
	$content .= js_PagesTable($Pages, $P_header_text, $P_show_col_titles, $P_f_col_txt, $P_s_col_txt);
if ($NSLookupPages > 0)
	$content .= js_NSLookupPagesTable($NSLookupPages, $NSLP_header_text, $NSLP_show_col_titles, $NSLP_f_col_txt, $NSLP_s_col_txt);


if ( ($UserVisits > 0) || ($NSLookupVisits > 0) || ($Pages > 0) || ($NSLookupPages > 0) )
	$content .= '</table>'."\n";
	

